<!--

  B E A   S Y S T E M S

  Copyright (c) 2005  BEA Systems, Inc.

  All Rights Reserved. Unpublished rights reserved under the copyright laws
  of the United States. The software contained on this media is proprietary
  to and embodies the confidential technology of BEA Systems, Inc. The
  possession or receipt of this information does not convey any right to disclose
  its contents, reproduce it, or use,  or license the use, for manufacture or
  sale, the information or anything described therein. Any use, disclosure, or
  reproduction without BEA System's prior written permission is strictly prohibited.

  This sample is for example purposes only and are not designed for production use.
  It serves as a companion to the WebLogic Portal Interaction Management Guide.

  This custom skeleton JSP performs the same function as the default
  skeleton JSP, but it also displatches a ResourceDisplayedEventBT
  when this skeleton renders book/page tabs and when users click book/page tabs.

 -->

<%@ page import="com.bea.netuix.servlets.controls.page.BookPresentationContext,
                 com.bea.netuix.servlets.controls.page.PagePresentationContext,
                 com.bea.netuix.servlets.controls.page.MenuPresentationContext"
%>

<!-- Additions for custom event generation -->
<%@ page import="com.bea.netuix.servlets.controls.portlet.PortletPresentationContext,
                 com.bea.p13n.tracking.TrackingEventHelper,
                 examples.events.ResourceDisplayedEventBT,
                 com.bea.p13n.http.Request" %>

<%@ taglib uri="render.tld" prefix="render" %>

<render:beginRender>

<%
    BookPresentationContext book = BookPresentationContext.getBookPresentationContext(request);
    MenuPresentationContext menu = (MenuPresentationContext) book.getFirstChild("page:menu");
    String bookClass = "bea-portal-book";
    String useBookClass = bookClass;

    if (book.isDesktopBook())
    {
        bookClass += "-primary";
        useBookClass = bookClass;
    }
    else if (book.isLikePage())
    {
        useBookClass += "-invisible";
    }

    String bookContentClass = bookClass + "-content";

    // Begin additions for page generation events ...
    ArrayList bookpages = book.getPagePresentationContexts();  // PagePresentationContexts

    ResourceDisplayedEventBT rde;
    String userId = request.getRemoteUser();

    if( userId == null || userId.length() == 0 )
        userId = new String("no login");

    String sessionId = request.getSession(false).getId();

    String pageTitle  = "";
    String resourceId = "";

    ListIterator li = bookpages.listIterator();
    while( li.hasNext())
    {
	Object next = li.next();

      PagePresentationContext pageCtx = (PagePresentationContext)next;
      pageTitle  = pageCtx.getTitle();  // Title of page being displayed. We treat books as pages.
      resourceId = pageCtx.getLabel();  // unique label, ie: "page_2"

          // NOTE: a BookPresentationContext is a PagePresentationContext, so a "page" can also be a
          // a book (BookPresentationContext)

      if( pageCtx.isVisible() )
      {

// Generate the event if the page/book tab is visible.
// The event attribute values are set in the code and passed in as arguments to the custom event
// in the expected order and as the expected type.

         rde = new ResourceDisplayedEventBT(  resourceId,   // resourceId,    unique label, ie: "page_2"
                                            pageTitle,            // resourceLabel, e.g., "Home"
                                            "page",               // resourceType
                                            sessionId,
                                            userId,
                                            "false",      //  just record that it's being displayed
                                            request,
                                            session );

         TrackingEventHelper.dispatchEvent( rde );
      }

      if( pageCtx.isActive() )  // this page is also selected
      {

// Generate the event if the page/book tab is selected.
// The event attribute values are set in the code and passed in as arguments to the custom event
// in the expected order and as the expected type.

         rde = new ResourceDisplayedEventBT(  resourceId,   // resourceId,    unique label, ie: "page_2"
                                            pageTitle,            // resourceLabel, e.g., "Home"
                                            "page",               // resourceType
                                            sessionId,
                                            userId,
                                            "true",      //  resourceSelected - page has also been selected
                                            request,
                                            session );

         TrackingEventHelper.dispatchEvent( rde );
      }
}

%>
    <!-- Begin Book -->
    <div
        <render:writeAttribute name="id" value="<%= book.getPresentationId() %>"/>
        <render:writeAttribute name="class" value="<%= book.getPresentationClass()%>" defaultValue="<%= useBookClass %>"/>
        <render:writeAttribute name="style" value="<%= book.getPresentationStyle() %>"/>
    >
        <render:renderChild presentationContext="<%= menu %>"/>
        <!-- Begin Book Content -->
        <div class="<%= bookContentClass %>">
</render:beginRender>

<render:endRender>
        </div>
        <!-- End Book Content -->
    </div>
    <!-- End Book -->
</render:endRender>
