<!--

  B E A   S Y S T E M S

  Copyright (c) 2005  BEA Systems, Inc.

  All Rights Reserved. Unpublished rights reserved under the copyright laws
  of the United States. The software contained on this media is proprietary
  to and embodies the confidential technology of BEA Systems, Inc. The
  possession or receipt of this information does not convey any right to disclose
  its contents, reproduce it, or use,  or license the use, for manufacture or
  sale, the information or anything described therein. Any use, disclosure, or
  reproduction without BEA System's prior written permission is strictly prohibited.

  This sample is for example purposes only and are not designed for production use.
  It serves as a companion to the WebLogic Portal Interaction Management Guide.

  This custom skeleton JSP performs the same function as the default
  skeleton JSP, but it also displatches a ResourceDisplayedEventBT
  when portlets are displayed on pages that are rendered by this skeleton JSP.

 -->
 
<%@ page import="com.bea.netuix.servlets.controls.page.PagePresentationContext,
                 com.bea.netuix.servlets.controls.page.BookPresentationContext"
%>

<!-- Additions for custom event generation -->
<%@ page import="com.bea.netuix.servlets.controls.portlet.PortletPresentationContext,
                 com.bea.p13n.tracking.TrackingEventHelper,
                 examples.events.ResourceDisplayedEventBT,
                 com.bea.p13n.http.Request" %>

<%@ taglib uri="render.tld" prefix="render" %>

<render:beginRender>
<%
    PagePresentationContext pageCtx = PagePresentationContext.getPagePresentationContext(request);
    BookPresentationContext book    = BookPresentationContext.getBookPresentationContext(request);

    // For custom events: page and portlet reporting
    
    boolean debug = false;

    ResourceDisplayedEventBT rde;
    PortletPresentationContext ppc;

    String userId = request.getRemoteUser();
    if( userId == null || userId.length() == 0 )
        userId = new String("no login");

    String sessionId = request.getSession(false).getId();

    String pageTitle = pageCtx.getTitle();  // Title of page being displayed
    String portletTitle;

    if( debug )
        System.out.println("page.jsp debug: page name: "+ pageTitle); // title of the page

    List portlets = pageCtx.getWindowPresentationContexts();

    if( debug )
    {
        System.out.println("There are "+portlets.size()+" portlets on this page");
        System.out.println("They are: ");
    }

    ListIterator li = portlets.listIterator();

    while( li.hasNext() )
    {
        Object next = li.next();
        // expensive, it should be a PortletPresentationContext so
        // we'll just catch an exception if it occurs
        // if( next instanceof PortletPresentationContext )
        try
        {
            ppc = (PortletPresentationContext)next;
            portletTitle = ppc.getTitle();
            if( ppc.isVisible() )
            {
               if( debug )
                  System.out.println("\tportlet on this page: "+portletTitle);

// Generate the event when portlets are displayed.
// The event attribute values are set in the code and passed in as arguments to the custom event
// in the expected order and as the expected type.

               rde = new ResourceDisplayedEventBT( ppc.getLabel(),  // resourceId,    unique label, ie: "portlet_3_1"
                                                 portletTitle,    // resourceLabel, ie: "My Portlet"
                                                 "portlet",       // resourceType
                                                 sessionId,
                                                 userId,
                                                 "true",          // portlet is being displayed
                                                 request,
                                                 session );
               // For campaigns (to trigger a campaign from an event), you must
               // have a BEA request attribute, and the event has to have a user-id value
               // set within it. This object has that, but we'll set the request programmatically
               // with the following line.

               rde.setAttribute("request", new Request(request, true));

               TrackingEventHelper.dispatchEvent( rde );
            }
        }
        catch( Exception e )
        {
            // nothing fancy, this is just a demo
            System.out.println("page.jsp caught: " +e.getMessage());
        }
     }

    // End of customizations for page and portlet reporting

    String bookClass = "bea-portal-book";

    if (book.isDesktopBook())
    {
        bookClass += "-primary";
    }

    String pageClass = bookClass + "-page";
%>
    <!-- Begin Page -->
    <div
        <render:writeAttribute name="id" value="<%= pageCtx.getPresentationId() %>"/>
        <render:writeAttribute name="class" value="<%= pageCtx.getPresentationClass() %>" defaultValue="<%= pageClass %>"/>
        <render:writeAttribute name="style" value="<%= pageCtx.getPresentationStyle() %>"/>
    >
</render:beginRender>
<render:endRender>
    </div>
    <!-- End Page -->
</render:endRender>
